import requests


def get_generic_channel_data(ID, instance, ssl=True):
    url = f"https://{instance}/api/v1/channels/{ID}?fields=author,authorId,authorUrl,subCount,totalViews,joined,paid,autoGenerated,isFamilyFriendly"
    if not ssl:
        url = url.replace("https://", "http://")
    data = requests.get(url).json()
    author = {
        "name": str(data["author"]),
        "id": str(data["authorId"]),
        "url": str(data["authorUrl"]),
    }
    inTotal = {
        "subs": int(data["subCount"]),
        "views": int(data["totalViews"]),
        "joined": int(data["joined"]),
    }
    extra = {
        "autoGenerated": bool(data["autoGenerated"]),
        "isFamilyFriendly": bool(data["isFamilyFriendly"]),
    }
    return author, inTotal, extra
