import requests, json


def get_video_data(ID, instance, ssl=True):
    url = f"https://{instance}/api/v1/videos/{ID}?fields=title,videoId,published,publishedText,viewCount,likeCount,paid,premium,isFamilyFriendly,genre,genreUrl,author,authorId,authorUrl,lengthSeconds,allowRatings,rating,isListed,liveNow,isUpcoming"
    if not ssl:
        url = url.replace("https://", "http://")
    data = json.loads(
        str(requests.get(url).content).replace("b'", "").replace("}'", "}")
    )
    general = {"title": str(data["title"])}
    author = {
        "name": str(data["author"]),
        "id": str(data["authorId"]),
        "url": str(data["authorUrl"]),
    }
    genre = {"genre": str(data["genre"]), "url": str(data["genreUrl"])}
    published = {
        "published": int(data["published"]),
        "text": str(data["publishedText"]),
    }
    extra = {
        "length": int(data["lengthSeconds"]),
        "allowRatings": bool(data["allowRatings"]),
        "rating": float(data["rating"]),
        "isListed": bool(data["isListed"]),
        "nowLive": bool(data["liveNow"]),
        "isUpcoming": bool(data["isUpcoming"]),
    }
    extra2 = {
        "paid": bool(data["paid"]),
        "premium": bool(data["premium"]),
        "isFamilyFriendly": bool(data["isFamilyFriendly"]),
    }
    inTotal = {"views": int(data["viewCount"]), "likes": int(data["likeCount"])}
    return data, general, author, genre, published, extra, extra2, inTotal
